#
#   Copyright (C) 2021 Reiko Asakura. All Rights Reserved.
#
#   Vita Development Suite PSP2 CMake Toolchains 0.1.3
#

# This module is shared by multiple languages; use include blocker.
if(__PSP2_COMPILER_GNU)
  return()
endif()
set(__PSP2_COMPILER_GNU 1)

macro(__psp2_compiler_gnu lang)

  set(CMAKE_${lang}_COMPILE_OPTIONS_PIC "")
  set(CMAKE_${lang}_COMPILE_OPTIONS_PIE "")
  set(_CMAKE_${lang}_PIE_MAY_BE_SUPPORTED_BY_LINKER NO)
  set(CMAKE_${lang}_LINK_OPTIONS_PIE "")
  set(CMAKE_${lang}_LINK_OPTIONS_NO_PIE "")

  string(APPEND CMAKE_${lang}_FLAGS_INIT " -fno-use-linker-plugin -funwind-tables -fcall-saved-r9 -fno-short-enums -fshort-wchar -fsigned-char -mabi=aapcs -mcpu=cortex-a9 -mfloat-abi=hard -mthumb -D_SCE_HOST_COMPILER_GCC=1 -D__psp2__=1 -nostdlib -nostdinc -isystem =/include -isystem =/include_common -iwithprefix include -iwithprefix include-fixed")
  string(APPEND CMAKE_${lang}_FLAGS_DEBUG_INIT " -Og -D_DEBUG")
  string(APPEND CMAKE_${lang}_FLAGS_MINSIZEREL_INIT " -fno-optimize-sibling-calls")
  string(APPEND CMAKE_${lang}_FLAGS_RELEASE_INIT " -fno-optimize-sibling-calls")
  string(APPEND CMAKE_${lang}_FLAGS_RELWITHDEBINFO_INIT " -fno-optimize-sibling-calls")

  set(CMAKE_SHARED_LIBRARY_CREATE_${lang}_FLAGS "-Wl,--oformat=prx")

  set(CMAKE_${lang}_OUTPUT_EXTENSION ".o")

  set(_CMAKE_${lang}_IPO_SUPPORTED_BY_CMAKE NO)
  set(_CMAKE_${lang}_IPO_MAY_BE_SUPPORTED_BY_COMPILER NO)

endmacro()
